"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 文件操作
 * Created at 2020-10-15 19:54
 *
 * @author Wheeler https://github.com/WheelerLee
 * @copyright 2020 Activatortube, INC.
 *
 */
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const colors_1 = __importDefault(require("colors"));
const ejs_1 = __importDefault(require("ejs"));
class FSUtils {
    /**
     * 复制types文件到项目
     */
    static copyTypes() {
        return __awaiter(this, void 0, void 0, function* () {
            yield fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../templates/to/@types'), path_1.default.resolve(process.cwd(), '@types'));
            if (yield fs_extra_1.default.pathExists(path_1.default.resolve(process.cwd(), 'tsconfig.json'))) {
                console.log(colors_1.default.warn('tsconfig.json已经存在，不会生成新的文件'));
            }
            else {
                yield fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../templates/to/tsconfig.json'), path_1.default.resolve(process.cwd(), 'tsconfig.json'));
            }
        });
    }
    /**
     * 将源文件翻译成目标代码文件
     * @param source 源文件
     * @param target 目标代码文件(可执行的代码)
     * @param data 额外数据
     */
    static translate(source, target, data) {
        return __awaiter(this, void 0, void 0, function* () {
            const template = yield fs_extra_1.default.readFile(source);
            const model = ejs_1.default.render(template.toString(), data);
            yield fs_extra_1.default.writeFile(target, Buffer.from(model), { flag: 'w', encoding: 'utf8' });
        });
    }
}
exports.default = FSUtils;
