"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const FSUtils_1 = __importDefault(require("./FSUtils"));
const generate = function (entity) {
    return __awaiter(this, void 0, void 0, function* () {
        const controllerRoot = path_1.default.resolve(process.cwd(), `api/controllers/${entity.moduleName}`);
        // const entityRoot = path.resolve(process.cwd(), `api/entities/${entity.moduleName}`);
        const viewRoot = path_1.default.resolve(process.cwd(), `views/${entity.moduleName}/${entity.name.toLowerCase()}`);
        const controllerFile = path_1.default.resolve(controllerRoot, `${entity.name}Controller.ts`);
        const indexViewFile = path_1.default.resolve(viewRoot, `index.ejs`);
        const modifyViewFile = path_1.default.resolve(viewRoot, `modify.ejs`);
        // if (fs.existsSync(controllerFile) || fs.existsSync(indexViewFile) || fs.existsSync(modifyViewFile)) {
        //   console.log(colors.red.bold(`请检查项目，已经存在相应文件`));
        //   return;
        // }
        console.log(entity.columns);
        fs_extra_1.default.ensureDirSync(controllerRoot);
        fs_extra_1.default.ensureDirSync(viewRoot);
        FSUtils_1.default.translate(path_1.default.resolve(__dirname, '../../templates/to/entity/Controller.ejs'), controllerFile, entity);
        FSUtils_1.default.translate(path_1.default.resolve(__dirname, '../../templates/to/entity/index.ejs'), indexViewFile, entity);
        FSUtils_1.default.translate(path_1.default.resolve(__dirname, '../../templates/to/entity/modify.ejs'), modifyViewFile, entity);
    });
};
/**
 * 按照表名生成增删改查方法
 * @param entities
 * @param table 表名
 */
const generateModel = function (entities = [], table) {
    return __awaiter(this, void 0, void 0, function* () {
        for (const entity of entities) {
            if (entity.tableName === table) {
                yield generate(entity);
                break;
            }
        }
    });
};
exports.default = generateModel;
