"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const inquirer_1 = __importDefault(require("inquirer"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const chalk_1 = __importDefault(require("chalk"));
/**
 * 初始化一个项目
 * @param name 项目名
 */
function init(name) {
    return __awaiter(this, void 0, void 0, function* () {
        const proPath = path_1.default.resolve(process.cwd(), name);
        console.log(proPath);
        if (fs_extra_1.default.existsSync(proPath)) {
            console.log(chalk_1.default.bgCyan(chalk_1.default.red(' 该文件夹已经存在 ')));
            return;
        }
        const answer = yield inquirer_1.default.prompt({
            type: 'list',
            name: 'templete',
            message: "选择项目的类型?",
            choices: [
                {
                    key: 'e',
                    name: '空项目',
                    value: 'empty'
                },
                {
                    key: 'a',
                    name: '后台管理',
                    value: 'admin'
                }
            ],
        });
        // 生成含后台的项目
        if (answer.templete === 'admin') {
            yield fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../templates/to/admin_templete'), proPath);
        }
        else {
            yield fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../templates/to/empty_templete'), proPath);
        }
    });
}
exports.init = init;
